#!/usr/bin/python
##### Toplotni in zrnati sum - S53MV 2.3.2018 #####

import math,cmath	#uporabljene funkcije

kb=1.38064852e-23	#Boltzmann
t=290			#sobna temperatura v K
tt=2.76			#temperatura prapoka v K
h=6.626070040e-34	#Planck

x=[]		#polja za risanje grafa
y1=[]
yy1=[]
y2=[]
y3=[]
yy3=[]
lw=2

k=0.03		#korak logaritma frekvence
lmin=8		#meje logaritma frekvence
lmax=15
tmin=1		#meje temperature
tmax=1e5

def toplotni(h,f,kb,t):	#toplotni sum z moznostjo prekoracitve
	try:
		s=h*f/kb/(math.exp((h*f)/(kb*t))-1)
	except OverflowError:
		s=0.0	
	return s

lf=lmin
while lf<=lmax+k:
	f=10**lf	#frekvenca
	x=x+[f]
	ts=toplotni(h,f,kb,t)	#sobni toplotni sum
	y1=y1+[ts]
	tts=toplotni(h,f,kb,tt)	#toplotni sum prapoka
	yy1=yy1+[tts]
	zs=h*f/kb	#temperatura zrnatega suma
	y2=y2+[zs]
	y3=y3+[ts+zs]	#vsota obeh sumov
	yy3=yy3+[tts+zs]
	lf=lf+k		#povecaj lf za korak

import matplotlib.pyplot as plt		#risanje grafa funkcije
fig=plt.figure()
plt.loglog(x,yy3,'g--',lw=lw)
plt.loglog(x,y3,'g-',lw=lw)
plt.loglog(x,yy1,'r--',lw=lw)
plt.loglog(x,y1,'r-',lw=lw)
plt.loglog(x,y2,'b-',lw=lw)
plt.axis([10**lmin,10**lmax,tmin,tmax])
plt.xlabel(r'Frekvenca $f$ [Hz]')
plt.ylabel(r'Spektralna gostota $N_0/k_B$ [K]')
plt.grid(True)
fig.savefig('sum.svg', transparent=True)
plt.show()

#konec programa

